package abstractfactory;

public class FabricaVehiculosEuropea implements FabricaVehiculos {

	@Override
	public Vehiculo creaVehiculo(TipoVehiculo tipoVehiculo) {
		FabricaComponentes fabricaComponentes = new FabricaComponentesEuropea();
		Vehiculo vehiculo = null;
		
		switch (tipoVehiculo) {
			case TURISMO:
				System.out.println("Fabricando un turismo europeo...");
				vehiculo = new Turismo(fabricaComponentes);
				break;
				
			case BERLINA:
				System.out.println("Fabricando una berlina europea...");
				vehiculo = new Berlina(fabricaComponentes);
				break;
				
			case DEPORTIVO:
				System.out.println("Fabricando un deportivo europeo...");
				vehiculo = new Deportivo(fabricaComponentes);
				break;
				
			default :
				System.out.println("Fabricando un turismo europeo...");
				vehiculo = new Turismo(fabricaComponentes);
				break;
		}
		
		return vehiculo;
	}

}
