package method;

import method.tipos.Item;
import method.tipos.cultural.AgendaCultural;
import method.tipos.cultural.TipoEvento;
import method.tipos.telefonica.AgendaTelefonica;
import method.tipos.telefonica.TipoEntrada;

public final class Principal {
	private Principal() {
		super();
	}
	
	private void ejecuta() {
		AgendaTelefonica agendaTelefonica = new AgendaTelefonica();
		Item entrada = agendaTelefonica.getItem(TipoEntrada.PERSONA);
		entrada.pedirDatos();
		agendaTelefonica.nuevaEntrada(entrada);
		entrada = agendaTelefonica.getItem(TipoEntrada.EMPRESA);
		entrada.pedirDatos();
		agendaTelefonica.nuevaEntrada(entrada);
		agendaTelefonica.mostrarEntradas();
		AgendaCultural agendaCultural = new AgendaCultural();
		entrada = agendaCultural.getItem(TipoEvento.CHARLA);
		entrada.pedirDatos();
		agendaCultural.nuevaEntrada(entrada);
		agendaCultural.mostrarEntradas();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Principal principal = new Principal();
		principal.ejecuta();
	}

}
