package sensores;

import java.util.Random;

import sensores.VelocidadViento.Direccion;

public class SensorVelocidadViento extends Sensor<VelocidadViento> {
	private static final float VELOCIDAD_MAXIMA = 100; 
	private Random viento = new Random();
	
	public SensorVelocidadViento() {
		super();
		setMedida();
		setDescripcion();
	}
	
	public final void setDescripcion() {
		super.setDescripcion("Mide la velocidad y direccin del viento.");
		
	}

	private final void setMedida() {
		float angulo = (float)(viento.nextFloat() * Math.PI);
		float seno = (float)(Math.sin(angulo));
		float coseno = (float)(Math.cos(angulo));
		medida = new VelocidadViento(VELOCIDAD_MAXIMA*viento.nextFloat(), seno, coseno);
	}
}
