package gui;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;

public final class EjemploClaseAdaptadora {
	private EjemploClaseAdaptadora() {
		super();
	}
	
	private void creaGUI() {
		// Creamos la ventana
		JFrame ventana = new JFrame("Escuchador con clase adaptadora.");
		// Aadimos como escuchador una instancia de una clase interna annima
		// que extiende a WindowAdapter y slo sobrescribe el mtodo windowClosing.
		ventana.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		ventana.setSize(400, 400);
		ventana.setVisible(true);		
	}
	
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {			
			@Override
			public void run() {
				new EjemploClaseAdaptadora().creaGUI();
			}
		});
	}
}
