package gui;

import java.awt.Container;

import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public final class EjemploJList {
	private EjemploJList() {
		super();
	}
	
	private void creaGUI() {
		JFrame ventana = new JFrame("Ejemplo JList");
		Container contenedor = ventana.getContentPane();
		JList opciones = new JList(new String[]{"Lunes", "Martes", "Mircoles", "Jueves", "Viernes", "Sbado", "Domingo"});
		opciones.setVisibleRowCount(5);
		opciones.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		opciones.addListSelectionListener(new Escuchador());
		JScrollPane scroll = new JScrollPane(opciones);
		contenedor.add(scroll);
		ventana.pack();
		ventana.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		ventana.setVisible(true);
	}
	
	private class Escuchador implements ListSelectionListener {
		@Override
		public void valueChanged(ListSelectionEvent e) {
			if(e.getValueIsAdjusting() == true)
				System.out.println("Item en curso: " + ((JList)e.getSource()).getSelectedValue());
			else if(e.getValueIsAdjusting() == false)
				System.out.println("Item definitivo: " + ((JList)e.getSource()).getSelectedValue());
		}		
	}

	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				new EjemploJList().creaGUI();
			}
		});
	}

}
