package buffer;

import java.util.Random;

public final class Principal {
	// Deja una de los Buffer descomentados para ver la ejecucin
	private BufferSinLock<Integer> contenedor = new BufferSinLock<Integer>(10);
//	private BufferConLock<Integer> contenedor = new BufferConLock<Integer>(10);
	private Random aleatorio = new Random(0);

	private Principal() {
		super();
	}

	private void ejecuta(final int tProducto, final int tConsumidor){
		Thread productor = new Thread(new Runnable() {			
			@Override
			public void run() {
				try {
					while(true) {
						contenedor.setDato(aleatorio.nextInt(100));
						Thread.sleep(tProducto);
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		});

		Thread consumidor = new Thread(new Runnable() {			
			@Override
			public void run() {
				try {
					while(true) {
						contenedor.getDato();
						Thread.sleep(tConsumidor);
					}
				} catch(InterruptedException e) {
					e.printStackTrace();
				}
			}
		});

		productor.start();
		consumidor.start();
	}

	public static void main(String[] args) {
		new Principal().ejecuta(Integer.parseInt(args[0]), Integer.parseInt(args[1]));
	}
}
