package estructuras;

import java.util.ArrayList;
import java.util.concurrent.locks.Lock;

public class Cliente {
	private int tiempo;
	private String nombre;
	private boolean activo;
	private Tienda tienda;
	private ArrayList<Producto> cesta = new ArrayList<Producto>();
	private static final int MAX = 3; //Compra 2 productos mximo de cada tipo
	private Thread hilo;
	private Lock consola;
	int cuantas = 1;

	public Cliente(int tiempo, Tienda tienda, String nombre, Lock consola) {
		this.tiempo = tiempo;
		this.tienda = tienda;
		this.nombre = nombre;
		this.consola = consola;
	}

	public void iniciaCompra() {
		hilo = new Thread(new Runnable() {
			@Override
			public void run() {
				activo = true;
				while(activo) {
					try {
						compraProductos();
						Thread.sleep(tiempo);
					} catch (InterruptedException e) {
						System.out.println(nombre + " estaba comprando y me han detenido.");
					}
				}
				System.out.println("Deteniendo cliente " + nombre);
			}
		});
		hilo.start();
	}

	private void muestraCesta() {
//		if(consola != null)
//			consola.lock();
//		try {
			System.out.print("===>>>   " + nombre + ": ");
			for(Producto producto: cesta)
				System.out.print(producto + ", ");
			System.out.println("   <<<===");
//		} finally {
//			if(consola != null)
//				consola.unlock();
//		}
	}

	private void compraProductos() throws InterruptedException {
		compraCarnes();
		compraPescados();
		compraVerduras();
		muestraCesta();
	}

	private void compraVerduras() throws InterruptedException {
//		int cuantas = (int)(Math.random()*MAX);
		for(int i = 0; i < cuantas; i++)
			cesta.add(tienda.compraVerdura(nombre));
	}

	private void compraPescados() throws InterruptedException {
//		int cuantos = (int)(Math.random()*MAX);
		for(int i = 0; i < cuantas; i++)
			cesta.add(tienda.compraPescado(nombre));
	}

	private void compraCarnes() throws InterruptedException {
//		int cuantas = (int)(Math.random()*MAX);
		for(int i = 0; i < cuantas; i++)
			cesta.add(tienda.compraCarne(nombre));
	}

	public void detenCompra() {
		activo = false;
//		hilo.interrupt();
	}
}
