package estructuras;

public class Proveedor {
	private int tiempo;
	private Tienda tienda;
	private boolean activo;
	private static final int MAX = 5; // Como mucho abastece 10 productos de cada tipo
	private Thread hilo;
	private int cuantas = 3;

	public Proveedor(int tiempo, Tienda tienda) {
		this.tiempo = tiempo;
		this.tienda = tienda;
	}

	public void iniciaAbastecimiento() {
		hilo = new Thread(new Runnable() {
			@Override
			public void run() {
				activo = true;
				while(activo) {
					try {
						abastece();
						Thread.sleep(tiempo);
					} catch (InterruptedException e) {
						System.out.println("Estaba abasteciendo y me han detenido.");
					}
				}
				System.out.println("Deteniendo abastecimiento...");
			}
		});
		hilo.start();
	}

	private void abastece() throws InterruptedException {
		abasteceCarnes();
		abastecePescados();
		abasteceVerduras();
	}

	private void abasteceVerduras() throws InterruptedException {
//		int cuantas = (int)(Math.random()*MAX);
		for(int i = 0; i < cuantas; i++)
			tienda.abasteceVerdura(Verduras.getVerdura());
	}

	private void abastecePescados() throws InterruptedException {
//		int cuantos = (int)(Math.random()*MAX);
		for(int i = 0; i < cuantas; i++)
			tienda.abastecePescado(Pescados.getPescado());
	}

	private void abasteceCarnes() throws InterruptedException {
//		int cuantas = (int)(Math.random()*MAX);
		for(int i = 0; i < cuantas; i++) 
			tienda.abasteceCarne(Carnes.getCarne());
	}

	public void detenAbastecimiento() {
		activo = false;
		hilo.interrupt();
	}
}
