package productoconsumidor;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class ContenedorConLock implements Contenedor {
	private int dato;
	private boolean datoDisponible;
	private Lock cerrojo = new ReentrantLock();
	private Condition condicion = cerrojo.newCondition();

	@Override
	public int get() throws InterruptedException {
		cerrojo.lock();
		try {
			while(datoDisponible == false)
				condicion.await();
			datoDisponible = false;
			System.out.println("Otros hilos en espera: " + ((ReentrantLock)cerrojo).hasWaiters(condicion));
			condicion.signalAll();
		} 
		finally {
			cerrojo.unlock();
		}
		return dato;
	}

	@Override
	public void put(int dato) throws InterruptedException {
		cerrojo.lock();
		try {
			while(datoDisponible == true)
				condicion.await();
			this.dato = dato;
			datoDisponible = true;
			System.out.println("Otros hilos en espera: " + ((ReentrantLock)cerrojo).hasWaiters(condicion));
			condicion.signalAll();
		} finally {
			cerrojo.unlock();
		}
	}
}
