package strategy;

import strategy.tipos.Agenda;
import strategy.tipos.Item;
import strategy.tipos.cultural.AgendaCultural;
import strategy.tipos.cultural.TipoEvento;
import strategy.tipos.telefonica.AgendaTelefonica;
import strategy.tipos.telefonica.TipoContacto;

public final class Principal {
	private Principal() {
		super();
	}
	
	private void ejecuta() {
		Agenda<TipoContacto> agendaTelefonica = new AgendaTelefonica();
		Item entrada = agendaTelefonica.getItem(TipoContacto.PERSONA);
		entrada.pedirDatos();
		agendaTelefonica.nuevaEntrada(entrada);
		entrada = agendaTelefonica.getItem(TipoContacto.EMPRESA);
		entrada.pedirDatos();
		agendaTelefonica.nuevaEntrada(entrada);
		agendaTelefonica.mostrarEntradas();
		Agenda<TipoEvento> agendaCultural = new AgendaCultural();
		entrada = agendaCultural.getItem(TipoEvento.CHARLA);
		entrada.pedirDatos();
		agendaCultural.nuevaEntrada(entrada);
		agendaCultural.mostrarEntradas();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Principal principal = new Principal();
		principal.ejecuta();
	}

}
