package strategy.tipos.cultural;

import strategy.tipos.Item;
import strategy.tipos.io.Escritor;
import strategy.tipos.io.Lector;

public class Charla extends Item {
	private String titulo;
	private String lugar;
	private String hora;
	private Lector<Charla> lector;
	private Escritor<Charla> escritor;
	
	public Charla() {
		super();
	}
	
	public Charla(Lector<Charla> lector, Escritor<Charla> escritor) {
		this.lector = lector;
		this.escritor = escritor;
	}
	
	public String getTitulo() {
		return titulo;
	}

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	public String getLugar() {
		return lugar;
	}

	public void setLugar(String lugar) {
		this.lugar = lugar;
	}

	public String getHora() {
		return hora;
	}

	public void setHora(String hora) {
		this.hora = hora;
	}

	@Override
	public void mostrarDatos() {
		escritor.escribeDatos(this);
	}

	@Override
	public void pedirDatos() {
		lector.leeDatos(this);
	}

}
