package strategy.tipos.telefonica;

import strategy.tipos.Agenda;
import strategy.tipos.Item;


public final class AgendaTelefonica extends Agenda<TipoContacto> {
	@Override
	public Item getItem(TipoContacto tipo) {
		switch(tipo) {
			case PERSONA :
				return new Persona(new LectorPersonaTeclado(),
								   new EscritorPersonaConsola());
			case EMPRESA :
				return new Empresa(new LectorEmpresaTeclado(),
								   new EscritorEmpresaConsola());
		}
		return null;
	}

}
