package strategy.tipos.telefonica;

import strategy.tipos.Item;
import strategy.tipos.io.Escritor;
import strategy.tipos.io.Lector;


public class Empresa extends Item {
	private String nombre;
	private String telefono;
	private Lector<Empresa> lector;
	private Escritor<Empresa> escritor;

	public Empresa() {
		super();
	}
	
	public Empresa(Lector<Empresa> lector, Escritor<Empresa> escritor) {
		this.lector = lector;
		this.escritor = escritor;
	}

	public void setLector(Lector<Empresa> lector) {
		this.lector = lector;
	}

	public void setEscritor(Escritor<Empresa> escritor) {
		this.escritor = escritor;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}

	@Override
	public void mostrarDatos() {
		escritor.escribeDatos(this);
	}

	@Override
	public void pedirDatos() {
		lector.leeDatos(this);
	}

}
